package tester

import (
	testerv1 "git.sch9.ru/new_gate/ms-tester/proto/tester/v1"
	"github.com/gofiber/fiber/v2"
)

type Handlers interface {
	ListContests(c *fiber.Ctx, params testerv1.ListContestsParams) error
	CreateContest(c *fiber.Ctx) error
	DeleteContest(c *fiber.Ctx, id int32) error
	GetContest(c *fiber.Ctx, id int32) error
	DeleteParticipant(c *fiber.Ctx, params testerv1.DeleteParticipantParams) error
	AddParticipant(c *fiber.Ctx, params testerv1.AddParticipantParams) error
	DeleteTask(c *fiber.Ctx, params testerv1.DeleteTaskParams) error
	AddTask(c *fiber.Ctx, params testerv1.AddTaskParams) error
	ListProblems(c *fiber.Ctx, params testerv1.ListProblemsParams) error
	CreateProblem(c *fiber.Ctx) error
	DeleteProblem(c *fiber.Ctx, id int32) error
	GetProblem(c *fiber.Ctx, id int32) error
	ListParticipants(c *fiber.Ctx, params testerv1.ListParticipantsParams) error
	UpdateProblem(c *fiber.Ctx, id int32) error
	UpdateContest(c *fiber.Ctx, id int32) error
}
